"use strict";
const vue = require("@vue/language-core");
const typescript_1 = require("@vue/typescript");
const externalFiles = new WeakMap();
const init = (modules) => {
    const { typescript: ts } = modules;
    const pluginModule = {
        create(info) {
            const virtualFiles = vue.createVirtualFiles(vue.createLanguages(info.languageServiceHost.getCompilationSettings(), getVueCompilerOptions(), ts));
            (0, typescript_1.decorateLanguageService)(virtualFiles, info.languageService, true);
            (0, typescript_1.decorateLanguageServiceHost)(virtualFiles, info.languageServiceHost, ts, ['.vue']);
            return info.languageService;
            function getVueCompilerOptions() {
                if (info.project.projectKind === ts.server.ProjectKind.Configured) {
                    const tsconfig = info.project.getProjectName();
                    return vue.createParsedCommandLine(ts, ts.sys, tsconfig).vueOptions;
                }
                else {
                    return vue.createParsedCommandLineByJson(ts, ts.sys, info.languageServiceHost.getCurrentDirectory(), {}).vueOptions;
                }
            }
        },
        getExternalFiles(project) {
            if (!externalFiles.has(project)) {
                externalFiles.set(project, (0, typescript_1.getExternalFiles)(ts, project, ['.vue']));
            }
            return externalFiles.get(project);
        },
    };
    return pluginModule;
};
module.exports = init;
//# sourceMappingURL=index.js.map